﻿using System.Runtime.Serialization;
using Cubicle.Core.Interfaces;

namespace Cubicle.Core.DataContracts
{
    [DataContract]
    public class ExportMetaData : IExportMetaData
    {
        
        public ExportMetaData(string name, string description, double version = 1.0)
        {
            Name = name;
            Description = description;
            Version = version;
        }

        public ExportMetaData(IExportMetaData meta)
        {
            Name = meta.Name;
            Description = meta.Description;
            Version = meta.Version;
        }

        #region Implementation of IExportMetaData

        [DataMember]
        public string Name { get; private set; }

        [DataMember]
        public string Description { get; private set; }

        [DataMember]
        public double Version { get; private set; }

        #endregion
    }
}
