﻿using System;
using System.ComponentModel.Composition;
using Cubicle.Core.Interfaces;

namespace Cubicle.Core.Processors.Parameter
{
    [Export("Cubicle.Processors.Parameter.PlainStringParameterResolver", typeof(IProcessor<ParameterRequest>))]
    [ExportMetadata("Name", "PlainStringParameterResolver")]
    [ExportMetadata("Description", "Resolves a non-special string parameter.")]
    public class PlainStringParameterResolver : ConditionalProcessor<ParameterRequest>
    {
        private readonly Type _stringType = typeof (string);

        #region Overrides of Processor<ParameterRequest>

        public override bool Condition(ParameterRequest request)
        {
            return request.SourceType == _stringType 
                   && request.TargetType == request.SourceType;
        }

        public override ParameterRequest ConditionalProcess(ParameterRequest request)
        {
            request.Complete(request.Source);
            return request;
        }

        #endregion
    }
}