﻿using System;
using System.Linq;

namespace Cubicle.Core.Repository.HandleParsers
{
    public class ExcelHandleParserDefault : ExcelHandleParserBase
    {
        public ExcelHandleParserDefault(char prefix, string name)
            : base(prefix, name) { }

        #region Overrides of HandleParser

        public override string KeyToHandle(string key)
        {
            var stripped = key[0] == Prefix ? key.Substring(1) : key;
            return String.IsNullOrEmpty(Name)
                       ? String.Join(SeparatorStr, PrefixStr, GetNextNumber(), stripped)
                       : String.Join(SeparatorStr, Name, PrefixStr, GetNextNumber(), stripped);
        }

        public override string HandleToKey(string handle)
        {
            return handle.Split(Separator).Last();
        }

        #endregion
    }
}