﻿using System;
using System.Linq;

namespace Cubicle.Core.Repository.HandleParsers
{
    public class ExcelHandleParserFixed : ExcelHandleParserBase
    {

        public ExcelHandleParserFixed(char prefix, string name)
            : base(prefix, name) { }

        #region Overrides of HandleParser

        public override string KeyToHandle(string key)
        {
            return String.IsNullOrEmpty(Name)
                       ? PrefixStr + SeparatorStr + key.Substring(1)
                       : String.Join(SeparatorStr, Name, PrefixStr, key.Substring(1));
        }

        public override string HandleToKey(string handle)
        {
            return handle.Split(Separator).Last();
        }

        #endregion
    }
}