﻿using System.Reflection;

namespace Cubicle.Excel.Binding
{
    /// <summary>
    /// TvW: This class encapsulates method-info and Excel meta-data
    /// </summary>
    public class ExcelMethodInfo
    {

        public MethodInfo TargetMethod;

        public string Name;			// Name of UDF/Macro in Excel
        public string Description;
        public bool IsHidden = false;		// For Functions only
        public string ShortCut;		// For macros only
        public string MenuName;		// For macros only
        public string MenuText;     // For macros only
        public string Category;
        public bool IsVolatile;
        public bool IsExceptionSafe = false;
        public bool IsMacroType = false;
        public bool IsThreadSafe = false;   // For Functions only
        public string HelpTopic;

        public ExcelParameterInfo[] Parameters;

    }
}
