﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using Cubicle.Core.Interfaces;
using Cubicle.Core.Processors;

namespace Cubicle.Excel.Processors
{
    [Export("Cubicle.Excel.Processors.MarshalChar", typeof(IProcessor<object>))]
    [ExportMetadata("Name", "MarshalChar")]
    [ExportMetadata("Description", "Casts Char to String.")]
    public class MarshalChar : ConditionalProcessor<object>
    {
        #region Overrides of Processor<InstructionRequest>

        private readonly Type _charType = typeof(Char);

        public override bool Condition(object request)
        {
            return request.GetType() == _charType;
        }

        public override object ConditionalProcess(object request)
        {
            return request.ToString();
        }

        #endregion
    }
}